
// 此方法由自定义 rollUp 插件注入，用于修复跨 webview clickout 事件不触发的问题
(function () {
  const electron = require('electron')
  const ipcRenderer = electron.ipcRenderer
  document.addEventListener('click', () => { ipcRenderer.send('CLICK_OUT_SIDE') })
  document.addEventListener('touchstart', () => { ipcRenderer.send('CLICK_OUT_SIDE') })
})(require);

// 此方法由自定义 rollUp 插件注入，用于修复 preload 在 electron 中路径依赖问题
(function (module, require) {
  if (/preload|renderer/.test(module.filename)) {
    module.paths.push(require('path').join(module.path, 'app.asar', 'node_modules'));
    console.log(module)
    window.__nodeRequire = require
  }
})(module, require);
'use strict';

function resetUI() {
  document.body.style.opacity = 0;
  setTimeout(() => {
    const settingIns = window.Common.Settings.instance();
    const screencastEnabledSetting =
      settingIns.registry.get('screencastEnabled');
    settingIns.createSetting('uiTheme', 'dark').set('dark');
    settingIns.createSetting('language', 'en').set('en');
    let needReload;
    if (screencastEnabledSetting && screencastEnabledSetting.value) {
      screencastEnabledSetting.set(0);
      needReload = true;
    }
    if (needReload) {
      window.location.reload();
    }
    if (
      window.UI &&
      window.UI.inspectorView &&
      window.UI.inspectorView._tabbedPane &&
      window.UI.inspectorView._tabbedPane._isShowing
    ) {
      document.body.style.opacity = 1;
      const tabbedPane = window.UI.inspectorView._tabbedPane;

      if (document.title.includes('service.html')) {
        tabbedPane.selectTab('console');
      } else {
        tabbedPane.selectTab('elements');
      }
      tabbedPane.leftToolbar().removeToolbarItems();
      tabbedPane.rightToolbar().removeToolbarItems();
    } else {
      window.requestAnimationFrame(resetUI);
    }
  }, 1000);
}
window.resetUI = resetUI;
window.requestAnimationFrame(resetUI);
